VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "    DirectX8"
   ClientHeight    =   7290
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6585
   LinkTopic       =   "Form1"
   ScaleHeight     =   7290
   ScaleWidth      =   6585
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame5 
      Caption         =   " 4 -   !!!"
      Height          =   1575
      Left            =   120
      TabIndex        =   10
      Top             =   5640
      Width           =   6375
      Begin VB.CommandButton cmdStop 
         Caption         =   ""
         Height          =   495
         Left            =   3360
         TabIndex        =   12
         Top             =   480
         Width           =   2775
      End
      Begin VB.CommandButton cmdStart 
         Caption         =   ""
         Height          =   495
         Left            =   240
         TabIndex        =   11
         Top             =   480
         Width           =   2775
      End
      Begin VB.Label lblBytesWritten 
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   1560
         TabIndex        =   14
         Top             =   1080
         Width           =   4575
      End
      Begin VB.Label Label3 
         Caption         =   " :"
         Height          =   255
         Left            =   240
         TabIndex        =   13
         Top             =   1080
         Width           =   1815
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   " 3 -  WAV-"
      Height          =   1575
      Left            =   120
      TabIndex        =   6
      Top             =   3960
      Width           =   6375
      Begin VB.CommandButton cmdCreateWAV 
         Caption         =   ""
         Height          =   495
         Left            =   240
         TabIndex        =   9
         Top             =   960
         Width           =   5895
      End
      Begin VB.TextBox txtPath 
         Height          =   285
         Left            =   840
         TabIndex        =   8
         Text            =   "c:\mycapture.wav"
         Top             =   480
         Width           =   5295
      End
      Begin VB.Label Label2 
         Caption         =   ":"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   480
         Width           =   1575
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   " 2 -    "
      Height          =   1095
      Left            =   120
      TabIndex        =   4
      Top             =   2760
      Width           =   6375
      Begin VB.CommandButton cmdCreateBuffer 
         Caption         =   ""
         Height          =   495
         Left            =   240
         TabIndex        =   5
         Top             =   360
         Width           =   5895
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   " 1 - "
      Height          =   2535
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6375
      Begin VB.ListBox lstFormats 
         Height          =   1230
         Left            =   240
         TabIndex        =   3
         Top             =   1080
         Width           =   5895
      End
      Begin VB.CommandButton cmdInitObjects 
         Caption         =   "&"
         Height          =   495
         Left            =   240
         TabIndex        =   1
         Top             =   240
         Width           =   5895
      End
      Begin VB.Label Label1 
         Caption         =   "  :"
         Height          =   255
         Left            =   240
         TabIndex        =   2
         Top             =   840
         Width           =   5895
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Implements DirectXEvent8

' DirectX8
Private objDX8 As DirectX8
'   
Private objDSCapture As DirectSoundCapture8
',    
Private objDSCaptureBuffer As DirectSoundCaptureBuffer8
'   
Private CaptureDesc As DSCBUFFERDESC

'    
'    ,    
Private lastPos As Long
'      
Private BytesWritten As Long
'     
Private EventStop As Long
'    ,    
Private EventNotify As Long

'  
Private CaptureCaps As DSCCAPS

'       WAV-
'    
Private Type FileHeader
  lRiff As Long
  lFileSize As Long
  lWave As Long
  lFormat As Long
  lFormatLength As Long
End Type
'    WAV
Private Type WaveFormat
  wFormatTag As Integer
  nChannels As Integer
  nSamplesPerSec As Long
  nAvgBytesPerSec As Long
  nBlockAlign As Integer
  wBitsPerSample As Integer
End Type
Private Type ChunkHeader
  lType As Long
  lLen As Long
End Type

Dim fh As FileHeader
Dim wf As WaveFormat
Dim ch As ChunkHeader

Private Sub cmdInitObjects_Click()
    '   
    '       
    Dim lngFormats As CONST_WAVEFORMATFLAGS
    '  DirectX8
    Set objDX8 = New DirectX8
    
    '  
    '    
    EventStop = objDX8.CreateEvent(Me)
    '     
    EventNotify = objDX8.CreateEvent(Me)
    
    '   .    vbNullString,  , 
    '      
    Set objDSCapture = objDX8.DirectSoundCaptureCreate(vbNullString)
    
    '  
    objDSCapture.GetCaps CaptureCaps

    '   
    lngFormats = CaptureCaps.lFormats
    lstFormats.Clear
    
    '       
    If (lngFormats And WAVE_FORMAT_1M08) > 0 Then lstFormats.AddItem "11.025 kHz, mono, 8-bit"
    If (lngFormats And WAVE_FORMAT_1M16) > 0 Then lstFormats.AddItem "11.025 kHz, mono, 16-bit"
    If (lngFormats And WAVE_FORMAT_1S08) > 0 Then lstFormats.AddItem "11.025 kHz, stereo, 8-bit"
    If (lngFormats And WAVE_FORMAT_1S16) > 0 Then lstFormats.AddItem "11.025 kHz, steroe, 16-bit"
    If (lngFormats And WAVE_FORMAT_2M08) > 0 Then lstFormats.AddItem "22.05 kHz, mono, 8-bit"
    If (lngFormats And WAVE_FORMAT_2M16) > 0 Then lstFormats.AddItem "22.05 kHz, mono, 16-bit"
    If (lngFormats And WAVE_FORMAT_2S08) > 0 Then lstFormats.AddItem "22.05 kHz, stereo, 8-bit"
    If (lngFormats And WAVE_FORMAT_2S16) > 0 Then lstFormats.AddItem "22.05 kHz, stereo, 16-bit"
    If (lngFormats And WAVE_FORMAT_4M08) > 0 Then lstFormats.AddItem "44.1 kHz, mono, 8-bit"
    If (lngFormats And WAVE_FORMAT_4M16) > 0 Then lstFormats.AddItem "44.1 kHz, mono, 16-bit"
    If (lngFormats And WAVE_FORMAT_4S08) > 0 Then lstFormats.AddItem "44.1 kHz, stereo, 8-bit"
    If (lngFormats And WAVE_FORMAT_4S16) > 0 Then lstFormats.AddItem "44.1 kHz, stereo, 16-bit"
End Sub

Private Sub cmdCreateBuffer_Click()
    '    
    
    ' 3 
    Dim tmp(0 To 2)  As DSBPOSITIONNOTIFY
    
    '  -   
    With tmp(0)
        .lOffset = 10000
        .hEventNotify = EventNotify
    End With
    With tmp(1)
        .lOffset = 30000
        .hEventNotify = EventNotify
    End With
    '   
    With tmp(2)
        .lOffset = DSBPN_OFFSETSTOP
        .hEventNotify = EventStop
    End With
    
    '   
    With CaptureDesc.fxFormat
        .nFormatTag = WAVE_FORMAT_PCM
        .nChannels = 2
        .lSamplesPerSec = 22050
        .nBitsPerSample = 16
        .nBlockAlign = .nBitsPerSample / 8 * .nChannels
        .lAvgBytesPerSec = .lSamplesPerSec * .nBlockAlign
        .nSize = 0
    End With
    
    CaptureDesc.lFlags = DSCBCAPS_DEFAULT
    ' .    5 
    CaptureDesc.lBufferBytes = CaptureDesc.fxFormat.lAvgBytesPerSec * 5
    
    ' 
    Set objDSCaptureBuffer = objDSCapture.CreateCaptureBuffer(CaptureDesc)
    
    '  
    objDSCaptureBuffer.SetNotificationPositions 3, tmp
End Sub

Private Sub cmdCreateWAV_Click()
    '  
    Dim strPath As String
    strPath = txtPath.Text
    
    '      
    Open strPath For Binary Access Write As #1
  
    ' 
    With fh
        .lRiff = &H46464952
        .lFileSize = 0   '    
        .lWave = &H45564157
        .lFormat = &H20746D66
        .lFormatLength = Len(wf)
    End With
    Put #1, , fh
    With wf
        .wFormatTag = CaptureDesc.fxFormat.nFormatTag
        .nChannels = CaptureDesc.fxFormat.nChannels
        .nSamplesPerSec = CaptureDesc.fxFormat.lSamplesPerSec
        .wBitsPerSample = CaptureDesc.fxFormat.nBitsPerSample
        .nBlockAlign = CaptureDesc.fxFormat.nBlockAlign
        .nAvgBytesPerSec = CaptureDesc.fxFormat.lAvgBytesPerSec
    End With
    Put #1, , wf
    ch.lType = &H61746164
    Put #1, , ch
End Sub

Private Sub cmdStart_Click()
    ' . DSCBSTART_LOOPING ,     ,
    '    .
    objDSCaptureBuffer.Start DSCBSTART_LOOPING
End Sub

Private Sub cmdStop_Click()
    '     
    objDSCaptureBuffer.Stop
End Sub

'     
Private Sub DirectXEvent8_DXCallback(ByVal eventid As Long)
    
    '    
    Dim curPos As Long
    Dim curs As DSCURSORS
    
    '  
    Dim dataBuf() As Byte
    '    
    Dim dataSize As Long
    
    '  
    objDSCaptureBuffer.GetCurrentPosition curs
    curPos = curs.lWrite  '       
       
    
    ',        ,
    '       
    dataSize = curPos - lastPos
    '    0,  ,    
    '          .
    '     : ,    
    ' (curPos),  ,      :
    '< >-lastPos.
    If dataSize < 0 Then
        dataSize = (CaptureDesc.lBufferBytes - lastPos) + curPos
    End If
    
    '   
    ReDim dataBuf(dataSize - 1)
    '    
    objDSCaptureBuffer.ReadBuffer lastPos, dataSize, dataBuf(0), DSCBLOCK_DEFAULT
        
    '       
    Put #1, , dataBuf
    BytesWritten = BytesWritten + dataSize
    
    lblBytesWritten.Caption = BytesWritten
    lastPos = curPos
    
    ' ,  
    Select Case eventid
        Case EventStop
            Debug.Print "DxEvent::Stop::    " & BytesWritten
        Case EventNotify
            Debug.Print "DxEvent::Notify::     " & dataSize & " "
    End Select
    
    '  "",     
    If (eventid = EventStop) Then
        CloseFile
    End If

End Sub

Private Sub CloseFile()
  Dim fsize As Long
  
  '    :   -    
  fsize = Len(fh) + Len(wf) + Len(ch) + BytesWritten
  Put #1, 5, fsize
  
  ' Rewrite data chunk header with size.
  
  '    Chunk
  ch.lLen = BytesWritten
  Put #1, Len(fh) + Len(wf) + 1, ch
  
  Close #1
End Sub

Private Sub Form_Unload(Cancel As Integer)
    '       
    
    '  ,   
    ' ,     ""
    If (objDSCaptureBuffer.GetStatus And DSCBSTATUS_CAPTURING) > 1 Then
        cmdStop.Value = True
    End If
    
    ' 
    objDX8.DestroyEvent EventStop
    objDX8.DestroyEvent EventNotify
    
    '   
    Set objDSCaptureBuffer = Nothing
    Set objDSCapture = Nothing
    Set objDX8 = Nothing
End Sub
